moSetGetConfigXml = {};

function moSetGetConfigXml:loadConfig(self, Xml, xmlNameTag)	
	moGeneralSettings.xml = Xml;
	--global mod
	local values = nil;
	local groupNameTag = (xmlNameTag.. ".global.mod(%d)"):format(0);
	if getXMLInt(Xml, groupNameTag.. "#updateInterval") then 
		local interval = getXMLInt(Xml, groupNameTag.. "#updateInterval");
		if tonumber(interval) < 2000 then interval = 2000;end;
		MultiOverlayV2.timerUpdate.interval = interval;
	end;
	--if getXMLBool(Xml, groupNameTag.. "#logSearchMapObjects") ~= nil then moGeneralSettings.logSearchMapObjects = getXMLBool(Xml, groupNameTag.. "#logSearchMapObjects");end;	
	if getXMLBool(Xml, groupNameTag.. "#artDesign") ~= nil then moGuiMiniPdaSlots.artDesign = getXMLBool(Xml, groupNameTag.. "#artDesign");end;
	if moGuiMiniPdaSlots.artDesign then
		if getXMLString(Xml, groupNameTag.. "#artDesignFile") ~= nil then 
			moGuiMiniPdaSlots.artDesignFile = getXMLString(Xml, groupNameTag.. "#artDesignFile");			
		else
			moGuiMiniPdaSlots.artDesign = false;
			moGuiMiniPdaSlots.artDesignName = "";
			moGuiMiniPdaSlots.artDesignFile = "";
		end;
	end;	
	if getXMLBool(Xml, groupNameTag.. "#helpText") ~= nil then moSetGetGui.helpText = getXMLBool(Xml, groupNameTag.. "#helpText");end;
	--if not moSetGetGui.helpText then moGuiExtras:setGetHelpText(self, false);end;	
	if getXMLBool(Xml, groupNameTag.. "#miniMap") ~= nil then moSetGetGui.miniMap.on = getXMLBool(Xml, groupNameTag.. "#miniMap");end;
	--if not moSetGetGui.miniMap then moGuiExtras:setGetMiniMap(self, false);end;	
	if getXMLBool(Xml, groupNameTag.. "#wtmHud") ~= nil then moSetGetGui.wtmHud.on = getXMLBool(Xml, groupNameTag.. "#wtmHud");end;	
	--if not moSetGetGui.wtmHud.on then moGuiExtras:setGetWtmHud(self, false);end;
	if getXMLBool(Xml, groupNameTag.. "#vsHud") ~= nil then moSetGetGui.vsHud.on = getXMLBool(Xml, groupNameTag.. "#vsHud");end;	
	--if not moSetGetGui.vsHud then moGuiExtras:setGetVsHud(self, false);end;
	if getXMLBool(Xml, groupNameTag.."#closeAllHud") ~= nil then moSetGetGui.closeAllHud = getXMLBool(Xml, groupNameTag.."#closeAllHud");end;
	if getXMLBool(Xml, groupNameTag.. "#adjustZoom") ~= nil then moSetGetGui.adjustZoom = getXMLBool(Xml, groupNameTag.. "#adjustZoom");end;
	if getXMLFloat(Xml, groupNameTag.. "#screenAspectRatio") then moSetGetGui.screenAspectRatio = getXMLFloat(Xml, groupNameTag.. "#screenAspectRatio");end;
	if getXMLBool(Xml, groupNameTag.. "#screenAspectRatioAuto") ~= nil then moSetGetGui.screenAspectRatioAuto = getXMLBool(Xml, groupNameTag.. "#screenAspectRatioAuto");end;
	if moSetGetGui.screenAspectRatioAuto then
		if g_screenAspectRatio >= 1.3 and g_screenAspectRatio <= 1.4 then moSetGetGui.screenAspectRatio = 2.3;end;
		if g_screenAspectRatio >= 1.25 and g_screenAspectRatio <= 1.29 then moSetGetGui.screenAspectRatio = 2.4;end;
		if g_screenAspectRatio >= 1.6 and g_screenAspectRatio <= 1.7 then moSetGetGui.screenAspectRatio = 1.2;end;
		if g_screenAspectRatio >= 1.7 then moSetGetGui.screenAspectRatio = 0;end;
	end;
	if getXMLInt(Xml, groupNameTag.. "#multiFarmSilo") then moGeneralSettings.multiFarmSilo = getXMLInt(Xml, groupNameTag.. "#multiFarmSilo");end;
	if getXMLFloat(Xml, groupNameTag.. "#pageCfgPosX") then values = getXMLFloat(Xml, groupNameTag.. "#pageCfgPosX");end;
	if values ~= nil and values < 1.0 and values > 0.0 then moSetGetGui.posCfgMenue.page[1] = values;end;
	if getXMLFloat(Xml, groupNameTag.. "#pageCfgPosY") then values = getXMLFloat(Xml, groupNameTag.. "#pageCfgPosY");end;
	if values ~= nil and values < 1.0 and values > 0.0 then moSetGetGui.posCfgMenue.page[2] = values;end;
	if getXMLBool(Xml, groupNameTag.. "#trainPrice") ~= nil then moGeneralSettings.isTrainPrice = getXMLBool(Xml, groupNameTag.. "#trainPrice");end;
	--global mod
	if not MultiOverlayV2.isMp then end;
	loadPages(self, xmlNameTag);
	loadGlobalWtmHud(self, xmlNameTag);
	loadGlobalVsHud(self, xmlNameTag);	
	loadGlobalMiniPda(self, xmlNameTag);
	loadMiniPdaSlots(self, xmlNameTag);
	loadGlobalFieldsInfo(self, xmlNameTag);
	loadVI(self, xmlNameTag);	
end;

function loadPages(self, xmlNameTag)	
	if moGeneralSettings.xml ~= nil then
		for a=1, moSetGetGui.maxPage do
			local groupNameTag = (xmlNameTag.. ".pages.values(%d)"):format(a-1);
			local idx = getXMLInt(moGeneralSettings.xml, groupNameTag.."#page");
			if idx == nil or groupNameTag == nil then				
				break;
			end;
			local values = nil;
			if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#maxSize") then values = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#maxSize");end;
			if values ~= nil and values < 0.021 then moSetGetGui.page[a].maxSize = values;end;
			values = nil;
			if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#minSize") then values = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#minSize");end;
			if values ~= nil and values > 0.008 then moSetGetGui.page[a].mainSize = values;end;
			values = nil;
			if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#size") then values = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#size");end;
			if values ~= nil and values <= moSetGetGui.page[a].maxSize then moSetGetGui.page[a].size = values;end;
			values = nil;
			if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#zoomOutInLevel") then values = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#zoomOutInLevel");end;
			if values ~= nil and values < moSetGetGui.page[a].maxSize and values >= 0.0001 then moSetGetGui.page[a].zoomOutInLevel = values;end;
			values = nil;
			if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#posX") then values = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#posX");end;
			if values ~= nil and values <= 1.0 and values >= 0.0 then moSetGetGui.page[a].posX = values;end;
			values = nil;
			if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#posY") then values = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#posY");end;
			if values ~= nil and values <= 1.0 and values >= 0.0 then moSetGetGui.page[a].posY = values;end;
			values = nil;			
			if getXMLBool(moGeneralSettings.xml, groupNameTag.."#isActive") ~= nil then values = getXMLBool(moGeneralSettings.xml, groupNameTag.."#isActive");end;
			if values ~= nil and values then moSetGetGui.activePage = a;end;
			values = nil;
			if getXMLBool(moGeneralSettings.xml, groupNameTag.."#isHiden") ~= nil then values = getXMLBool(moGeneralSettings.xml, groupNameTag.."#isHiden");end;
			if values ~= nil and values then moSetGetGui.page[a].isHiden = values;end;
			values = nil;
			if a == 1 then				
				if getXMLBool(moGeneralSettings.xml, groupNameTag.."#allPrices") ~= nil then values = getXMLBool(moGeneralSettings.xml, groupNameTag.."#allPrices");end;
				if values ~= nil and values then moSetGetGui.page[a].allPrices = values;end;
				values = nil;
				if getXMLBool(moGeneralSettings.xml, groupNameTag.."#allFruits") ~= nil then values = getXMLBool(moGeneralSettings.xml, groupNameTag.."#allFruits");end;
				if values ~= nil and values then moSetGetGui.page[a].allFruits = values;end;
				values = nil;
				if getXMLInt(moGeneralSettings.xml, groupNameTag.."#maxFruitsProSwitch") then values = getXMLInt(moGeneralSettings.xml, groupNameTag.."#maxFruitsProSwitch");end;
				if values ~= nil and values > 7 then moSetGetGui.page[a].maxFruitsProSwitch = values;moSetGetFillTypes:setFruitsMaxProSwitch(self);moSetGetFillTypes:setFruitsFirstEnd(self);end;
				values = nil;
				--if getXMLInt(moGeneralSettings.xml, groupNameTag.."#fruitsSwitch") then values = getXMLInt(moGeneralSettings.xml, groupNameTag.."#fruitsSwitch");end;
				--if values ~= nil and values <= (moGeneralSettings.Fillable_NUM_FILLTYPES/2) then moSetGetGui.page[a].fruitsSwitch = values;end;
				--values = nil;
				if getXMLInt(moGeneralSettings.xml, groupNameTag.."#maxStationsProSwitch") then values = getXMLInt(moGeneralSettings.xml, groupNameTag.."#maxStationsProSwitch");end;
				if values ~= nil and values > 1 then moSetGetGui.page[a].maxStationsProSwitch = values;moSetGetStationes:setStationsMaxProSwitch(self);moSetGetStationes:setFirstEndStations(self);end;
				values = nil;
			end;
			if a == 2 then
				if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeGreatDemand") ~= nil then MultiOverlayV2.event.greatDemand_c = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeGreatDemand");end;
				if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeDiscount") ~= nil then MultiOverlayV2.event.discount_c = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeDiscount");end;
				if getXMLInt(moGeneralSettings.xml, groupNameTag.."#switch") then values = getXMLInt(moGeneralSettings.xml, groupNameTag.."#switch");end;
				if values ~= nil and values > 0 and values <= 3 then moSetGetGui.page[a].switch = values;end;
				values = nil;
			end;
		end;
	end;
end;

function loadGlobalWtmHud(self, xmlNameTag)
	local groupNameTag = (xmlNameTag.. ".global.wtmHud(%d)"):format(0);
	if moGeneralSettings.xml ~= nil and groupNameTag ~= nil then
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#newWtmHud") ~= nil then moSetGetGui.wtmHud.mohHud = getXMLBool(moGeneralSettings.xml, groupNameTag.."#newWtmHud");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#wtmHudRight") ~= nil then moSetGetGui.wtmHud.mohHudRight = getXMLBool(moGeneralSettings.xml, groupNameTag.."#wtmHudRight");end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#size") then moSetGetGui.wtmHud.size = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#size");end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#zoomOutIn") then moSetGetGui.wtmHud.zoomOutIn = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#zoomOutIn");end;
		if moSetGetGui.wtmHud.size > moSetGetGui.wtmHud.maxSize or moSetGetGui.wtmHud.size < moSetGetGui.wtmHud.minSize then moSetGetGui.wtmHud.size = 0.012;moSetGetGui.wtmHud.zoomOutIn=2.3;end;		
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#previewWeather") ~= nil then moSetGetGui.wtmHud.previewWeather = getXMLBool(moGeneralSettings.xml, groupNameTag.."#previewWeather");end;		
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#previewMoneyChangeLast") ~= nil then moSetGetGui.wtmHud.previewMoneyChangeLast = getXMLBool(moGeneralSettings.xml, groupNameTag.."#previewMoneyChangeLast");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#lsMoneyChange") ~= nil then moSetGetGui.wtmHud.lsMoneyChange = getXMLBool(moGeneralSettings.xml, groupNameTag.."#lsMoneyChange");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#lsMoneyChangeTimer") then moSetGetGui.wtmHud.lsMoneyChangeTimer = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#lsMoneyChangeTimer");end;
		if moSetGetGui.wtmHud.lsMoneyChangeTimer ~= 2500 then g_currentMission.moneyChange.maxDuration = moSetGetGui.wtmHud.lsMoneyChangeTimer;end;		
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#moneyChange") ~= nil then moSetGetGui.wtmHud.moneyChange = getXMLBool(moGeneralSettings.xml, groupNameTag.."#moneyChange");end;		
		if not moSetGetGui.wtmHud.lsMoneyChange and not moSetGetGui.wtmHud.moneyChange then g_currentMission.moneyChange.maxDuration = 0;end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#moneyChangeSound") ~= nil then moSetGetGui.wtmHud.moneyChangeSound = getXMLBool(moGeneralSettings.xml, groupNameTag.."#moneyChangeSound");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#moneyChangePos") then moSetGetGui.wtmHud.moneyChangePos = getXMLInt(moGeneralSettings.xml, groupNameTag.."#moneyChangePos");end;
		if moSetGetGui.wtmHud.moneyChangePos < 1 or moSetGetGui.wtmHud.moneyChangePos > 5 then moSetGetGui.wtmHud.moneyChangePos = 1;end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#realTime") ~= nil then moSetGetGui.wtmHud.realTime = getXMLBool(moGeneralSettings.xml, groupNameTag.."#realTime");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#realTimeColor") and moSetGetGui.wtmHud.realTimeColors[getXMLInt(moGeneralSettings.xml, groupNameTag.."#realTimeColor")] ~= nil then moSetGetGui.wtmHud.realTimeColor = getXMLInt(moGeneralSettings.xml, groupNameTag.."#realTimeColor");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeTemp") ~= nil then moSetGetGui.wtmHud.seeTemp = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeTemp");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#gameDay") ~= nil then moSetGetGui.wtmHud.gameDay = getXMLBool(moGeneralSettings.xml, groupNameTag.."#gameDay");end;		
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#isHiden") ~= nil then moSetGetGui.wtmHud.isHiden = getXMLBool(moGeneralSettings.xml, groupNameTag.."#isHiden");end;
		if not MultiOverlayV2.isMp and getXMLBool(moGeneralSettings.xml, groupNameTag.."#saveWeather") ~= nil then MultiOverlayV2.event.saveWeather_s = getXMLBool(moGeneralSettings.xml, groupNameTag.."#saveWeather");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#design") then moSetGetGui.wtmHud.design = getXMLInt(moGeneralSettings.xml, groupNameTag.."#design");end;
		if moSetGetGui.wtmHud.design ~= 1 and moSetGetGui.wtmHud.design ~= 2 then moSetGetGui.wtmHud.design = 1;end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#posX") then moSetGetGui.wtmHud.posX = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#posX");end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#posY") then moSetGetGui.wtmHud.posY = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#posY");end;
		if not MultiOverlayV2.isMp and MultiOverlayV2.event.saveWeather_s then
			MultiOverlayV2:loadWeatherServer(self, true);
			--local b = 0;
			--for a=1, 14 do
			--	groupNameTag = (xmlNameTag.. ".weather.values(%d)"):format(a-1);
			--	local idx = getXMLInt(moGeneralSettings.xml, groupNameTag.."#day");
			--	if idx == nil or groupNameTag == nil then				
			--		break;
			--	end;
			--	moSetGetGui.wtmHud.weatherDays[a] = {};
			--	if getXMLInt(moGeneralSettings.xml, groupNameTag.."#tempD") and getXMLInt(moGeneralSettings.xml, groupNameTag.."#tempN") and getXMLString(moGeneralSettings.xml, groupNameTag.. "#type") ~= nil then 
			--		moSetGetGui.wtmHud.weatherDays[a].tempDay = getXMLInt(moGeneralSettings.xml, groupNameTag.."#tempD");
			--		moSetGetGui.wtmHud.weatherDays[a].tempNight = getXMLInt(moGeneralSettings.xml, groupNameTag.."#tempN");					
			--		moSetGetGui.wtmHud.weatherDays[a].weatherType = getXMLString(moGeneralSettings.xml, groupNameTag.. "#type");					
			--		b = b+1;
			--	end;
			--end;
			--if b == 14 then moSetGetGui.wtmHud.loadWeather = true;end;				
		end;		
	end;
end;

function loadGlobalVsHud(self, xmlNameTag)	
	local groupNameTag = (xmlNameTag.. ".global.vsHud(%d)"):format(0);
	if moGeneralSettings.xml ~= nil and groupNameTag ~= nil then
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#fruitNamesOn") ~= nil then moSetGetGui.vsHud.fruitNamesOn = getXMLBool(moGeneralSettings.xml, groupNameTag.."#fruitNamesOn");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#fillPriceOn") ~= nil then moSetGetGui.vsHud.fillPriceOn = getXMLBool(moGeneralSettings.xml, groupNameTag.."#fillPriceOn");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#fillPriceStat") then moSetGetGui.vsHud.fillPriceStat = getXMLInt(moGeneralSettings.xml, groupNameTag.."#fillPriceStat");end;
		if moSetGetGui.vsHud.fillPriceStat < 0 or moSetGetGui.vsHud.fillPriceStat > 4 then moSetGetGui.vsHud.fillPriceStat = 0;end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#fillPriceIcon") ~= nil then moSetGetGui.vsHud.fillPriceIcon = getXMLBool(moGeneralSettings.xml, groupNameTag.."#fillPriceIcon");end;
		if moSetGetGui.vsHud.fillPriceIcon then moSetGetGui.vsHud.fillPriceStat = 1;end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#newFruitHuds") ~= nil then moSetGetGui.vsHud.newFruitHuds = getXMLBool(moGeneralSettings.xml, groupNameTag.."#newFruitHuds");end;
		if moSetGetGui.vsHud.fruitNamesOn then
			if getXMLBool(moGeneralSettings.xml, groupNameTag.."#fruitName") ~= nil then moSetGetGui.vsHud.fruitName = getXMLBool(moGeneralSettings.xml, groupNameTag.."#fruitName");end;
			if not moSetGetGui.vsHud.fruitName then
				if getXMLBool(moGeneralSettings.xml, groupNameTag.."#regName") ~= nil then moSetGetGui.vsHud.descName = getXMLBool(moGeneralSettings.xml, groupNameTag.."#regName");end;
				if not moSetGetGui.vsHud.descName then moSetGetGui.vsHud.fruitNamesOn = false;end;
			end;
		end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#fruitNamePos") then moSetGetGui.vsHud.fruitNamePos = getXMLInt(moGeneralSettings.xml, groupNameTag.."#fruitNamePos");end;
		if moSetGetGui.vsHud.fruitNamePos > 3 or moSetGetGui.vsHud.fruitNamePos < 1 then moSetGetGui.vsHud.fruitNamePos = 1;end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#fruitNameSize") then moSetGetGui.vsHud.fruitNameSize = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#fruitNameSize");end;
		if moSetGetGui.vsHud.fruitNameSize > moSetGetGui.vsHud.fruitNameMaxSize or moSetGetGui.vsHud.fruitNameSize < moSetGetGui.vsHud.fruitNameMinSize then moSetGetGui.vsHud.fruitNameSize = 0.010;end;
	end;
end;

function loadGlobalFieldsInfo(self, xmlNameTag)	
	local groupNameTag = (xmlNameTag.. ".global.fieldsInfo(%d)"):format(0);
	if moGeneralSettings.xml ~= nil and groupNameTag ~= nil then
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#iconDesign") ~= nil then moGuiMiniPdaSlots.fieldsInfo.iconDesign = getXMLBool(moGeneralSettings.xml, groupNameTag.."#iconDesign");end;		
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeSeeds") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeSeeds = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeSeeds");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeHarvest") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeHarvest = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeHarvest");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeGrowth") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeGrowth = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeGrowth");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeFertilizer") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeFertilizer = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeFertilizer");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeCut") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeCut = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeCut");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeRotten") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeRotten = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeRotten");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seePlough") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seePlough = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seePlough");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeWindrow") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeWindrow = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeWindrow");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeBale") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeBale = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeBale");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeSoil") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeSoil = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeSoil");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeGrass") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeGrass = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeGrass");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeHectar") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeHectar = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeHectar");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeError") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeError = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeError");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeFillLevel") ~= nil then moGuiMiniPdaSlots.fieldsInfo.seeFillLevel = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeFillLevel");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#autoClose") ~= nil then moGuiMiniPdaSlots.fieldsInfo.autoCloseExtraDraw = getXMLBool(moGeneralSettings.xml, groupNameTag.."#autoClose");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#ignoreGrass") then moGuiMiniPdaSlots.fieldsInfo.ignoreGrass = getXMLInt(moGeneralSettings.xml, groupNameTag.."#ignoreGrass");end;
		if moGuiMiniPdaSlots.fieldsInfo.ignoreGrass > 100 or moGuiMiniPdaSlots.fieldsInfo.ignoreGrass < 0 then moGuiMiniPdaSlots.fieldsInfo.ignoreGrass = 1;end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#ignoreMax") then moGuiMiniPdaSlots.fieldsInfo.ignoreMax = getXMLInt(moGeneralSettings.xml, groupNameTag.."#ignoreMax");end;
		if moGuiMiniPdaSlots.fieldsInfo.ignoreMax > 100 or moGuiMiniPdaSlots.fieldsInfo.ignoreMax < 0 then moGuiMiniPdaSlots.fieldsInfo.ignoreMax = 0;end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#iconSwitch") then moGuiMiniPdaSlots.fieldsInfo.iconSwitch = getXMLInt(moGeneralSettings.xml, groupNameTag.."#iconSwitch");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#textSwitch") then moGuiMiniPdaSlots.fieldsInfo.textSwitch = getXMLInt(moGeneralSettings.xml, groupNameTag.."#textSwitch");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#seeFields") then moGuiMiniPdaSlots.fieldsInfo.seeFields = getXMLInt(moGeneralSettings.xml, groupNameTag.."#seeFields");end;
		if moGuiMiniPdaSlots.fieldsInfo.seeFields > 2 or moGuiMiniPdaSlots.fieldsInfo.seeFields < 0 then moGuiMiniPdaSlots.fieldsInfo.seeFields = 1;end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#updateSwitch") then moGuiMiniPdaSlots.fieldsInfo.updateSwitch = getXMLInt(moGeneralSettings.xml, groupNameTag.."#updateSwitch");end;
		if moGuiMiniPdaSlots.fieldsInfo.updateSwitch > 3 or moGuiMiniPdaSlots.fieldsInfo.updateSwitch < 0 then moGuiMiniPdaSlots.fieldsInfo.updateSwitch = 0;end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#calculation") then moGuiMiniPdaSlots.fieldsInfo.calculation = getXMLInt(moGeneralSettings.xml, groupNameTag.."#calculation");end;
		if moGuiMiniPdaSlots.fieldsInfo.calculation > 3 or moGuiMiniPdaSlots.fieldsInfo.calculation < 1 then moGuiMiniPdaSlots.fieldsInfo.calculation = 1;end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#extraDrawPos") then moGuiMiniPdaSlots.fieldsInfo.extraDrawPos = getXMLInt(moGeneralSettings.xml, groupNameTag.."#extraDrawPos");end;
		if moGuiMiniPdaSlots.fieldsInfo.extraDrawPos > 1 or moGuiMiniPdaSlots.fieldsInfo.extraDrawPos < 0 then moGuiMiniPdaSlots.fieldsInfo.calculation = 0;end;
	end;
end;

function loadGlobalMiniPda(self, xmlNameTag)	
	local groupNameTag = (xmlNameTag.. ".global.miniPda(%d)"):format(0);
	if moGeneralSettings.xml ~= nil and groupNameTag ~= nil then
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#isActive") ~= nil then moGuiMiniPdaSlots.isActive = getXMLBool(moGeneralSettings.xml, groupNameTag.."#isActive");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#activeTotal") then moGuiMiniPdaSlots.activeTotal = getXMLInt(moGeneralSettings.xml, groupNameTag.."#activeTotal");end;
		if moGuiMiniPdaSlots.activeTotal == 0 or moGuiMiniPdaSlots.activeTotal > moGuiMiniPdaSlots.slotsMax then moGuiMiniPdaSlots.activeTotal = 0;moGuiMiniPdaSlots.isActive=false;moGuiMiniPdaSlots.activeName = "";end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#warningTakt") then moGuiMiniPdaSlots.warningBlinkTime = getXMLInt(moGeneralSettings.xml, groupNameTag.."#warningTakt");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#isHiden") ~= nil then moGuiMiniPdaSlots.isHiden = getXMLBool(moGeneralSettings.xml, groupNameTag.."#isHiden");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#isKeySwitchActive") ~= nil then moGuiMiniPdaSlots.isKeySwitchActive = getXMLBool(moGeneralSettings.xml, groupNameTag.."#isKeySwitchActive");end;
		--if getXMLInt(moGeneralSettings.xml, groupNameTag.."#keySwitchLast") then moGuiMiniPdaSlots.keySwitchLast = getXMLInt(moGeneralSettings.xml, groupNameTag.."#keySwitchLast");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#combiBgaSilo") ~= nil then moGuiMiniPdaSlots.combiBgaSilo = getXMLBool(moGeneralSettings.xml, groupNameTag.."#combiBgaSilo");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#onlyObjectSettings") ~= nil then moGuiMiniPdaSlots.onlyObjectSettings = getXMLBool(moGeneralSettings.xml, groupNameTag.."#onlyObjectSettings");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#alignment") then moGuiMiniPdaSlots.alignment = getXMLInt(moGeneralSettings.xml, groupNameTag.."#alignment");end;
		if moGuiMiniPdaSlots.alignment ~= 0 and moGuiMiniPdaSlots.alignment ~= 1 then moGuiMiniPdaSlots.alignment = 0;end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#isDouble") ~= nil then moGuiMiniPdaSlots.double = getXMLBool(moGeneralSettings.xml, groupNameTag.."#isDouble");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#isTriple") ~= nil then 
			moGuiMiniPdaSlots.triple = getXMLBool(moGeneralSettings.xml, groupNameTag.."#isTriple");
			if moGuiMiniPdaSlots.triple then moGuiMiniPdaSlots.double=false;end;
		end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#zoomOutIn") then moGuiMiniPdaSlots.zoomOutIn = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#zoomOutIn");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#distanceOut") then 
			moGuiMiniPdaSlots.distanceOut = getXMLInt(moGeneralSettings.xml, groupNameTag.."#distanceOut");
			if moGuiMiniPdaSlots.distanceOut > 0 then  moGuiMiniPdaSlots.distanceOutDefault = moGuiMiniPdaSlots.distanceOut;end;
		else
			if getXMLInt(moGeneralSettings.xml, groupNameTag.."#distanceIn") then moGuiMiniPdaSlots.distanceIn = getXMLInt(moGeneralSettings.xml, groupNameTag.."#distanceIn");end;
			if moGuiMiniPdaSlots.distanceIn > 0 then  moGuiMiniPdaSlots.distanceInDefault = moGuiMiniPdaSlots.distanceIn;end;
		end;		
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#maxZoom") then moGuiMiniPdaSlots.maxZoom = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#maxZoom");end;
		if tonumber(moGuiMiniPdaSlots.maxZoom) > 5.625 then moGuiMiniPdaSlots.maxZoom = 5.625;end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#minZoom") then moGuiMiniPdaSlots.minZoom = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#minZoom");end;
		if tonumber(moGuiMiniPdaSlots.minZoom) < 1.875 then moGuiMiniPdaSlots.minZoom = 1.875;end;
		if tonumber(moGuiMiniPdaSlots.zoomOutIn) > moGuiMiniPdaSlots.maxZoom or tonumber(moGuiMiniPdaSlots.zoomOutIn) < moGuiMiniPdaSlots.minZoom then moGuiMiniPdaSlots.zoomOutIn = 2.5;end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#posX") then moGuiMiniPdaSlots.posX = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#posX");end;
		if tonumber(moGuiMiniPdaSlots.posX) > 1.0 or tonumber(moGuiMiniPdaSlots.posX) < 0.0 then moGuiMiniPdaSlots.posX = 0.3;end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#posY") then moGuiMiniPdaSlots.posY = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#posY");end;
		if tonumber(moGuiMiniPdaSlots.posY) > 1.0 or tonumber(moGuiMiniPdaSlots.posY) < 0.0 then moGuiMiniPdaSlots.posY = 0.92;end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#defaultSlotOpenX") then moGuiMiniPdaSlots.defaultOpenX = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#defaultSlotOpenX");end;
		if tonumber(moGuiMiniPdaSlots.defaultOpenX) > 1.0 or tonumber(moGuiMiniPdaSlots.defaultOpenX) < 0.0 then moGuiMiniPdaSlots.posX = 1.0;end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#defaultSlotOpenY") then moGuiMiniPdaSlots.defaultOpenY = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#defaultSlotOpenY");end;
		if tonumber(moGuiMiniPdaSlots.defaultOpenY) > 1.0 or tonumber(moGuiMiniPdaSlots.defaultOpenY) < 0.0 then moGuiMiniPdaSlots.posY = 0.854519;end;
	end;
end;

function loadMiniPdaSlots(self, xmlNameTag)	
	if moGeneralSettings.xml ~= nil then		
		local foundSlotName = "";		
		for a=1, moGuiMiniPdaSlots.slotsMax do			
			local groupNameTag = (xmlNameTag.. ".miniPDA.values(%d)"):format(a-1);
			local slotName = nil;
			local errorSlot = false;
			local errorTxt = "";
			local idx = getXMLInt(moGeneralSettings.xml, groupNameTag.."#slot");
			if idx == nil or groupNameTag == nil then				
				break;
			end;					
			if getXMLString(moGeneralSettings.xml, groupNameTag.."#name") and string.find(moGuiMiniPdaSlots.acceptedName, getXMLString(moGeneralSettings.xml, groupNameTag.."#name")) then
				slotName = getXMLString(moGeneralSettings.xml, groupNameTag.."#name");				
				if not string.find(foundSlotName, slotName.. " ") then				
					foundSlotName = foundSlotName.. slotName.. " ";
					moGuiMiniPdaSlots.activeName = moGuiMiniPdaSlots.activeName.. slotName.. " ";
					local slot = table.getn(moGuiMiniPdaSlots.values)+1;
					moGuiMiniPdaSlots.values[slot] = {};				
					moGuiMiniPdaSlots.values[slot].name = slotName;
					moGuiMiniPdaSlots.values[slot].switch = 0;
					moGuiMiniPdaSlots.values[slot].maxProSwitch = 4;					
					moGuiMiniPdaSlots.values[slot].maxSwitch = 1;
					moGuiMiniPdaSlots.values[slot].firstObject = 1;
					moGuiMiniPdaSlots.values[slot].endObject = 4;
					moGuiMiniPdaSlots.values[slot].isOpen = false;
					moGuiMiniPdaSlots.values[slot].settings = false;
					moGuiMiniPdaSlots.values[slot].closeOpenHud = true;
					moGuiMiniPdaSlots.values[slot].closeAllHud = false;
					moGuiMiniPdaSlots.values[slot].closeAllHudTemp = {true, true, true, true};
					moGuiMiniPdaSlots.values[slot].setMouseCursorOn = false;
					moGuiMiniPdaSlots.values[slot].moreInfo = false;
					moGuiMiniPdaSlots.values[slot].productivity = 100;
					moGuiMiniPdaSlots.values[slot].isWarning = 0;
					moGuiMiniPdaSlots.values[slot].warningTime = 0;
					moGuiMiniPdaSlots.values[slot].openX = moGuiMiniPdaSlots.defaultOpenX;
					moGuiMiniPdaSlots.values[slot].openY = moGuiMiniPdaSlots.defaultOpenY;
					moGuiMiniPdaSlots.values[slot].posX = 0;
					moGuiMiniPdaSlots.values[slot].posY = 0;
					moGuiMiniPdaSlots.values[slot].distanceLine = 0.005;
					moGuiMiniPdaSlots.values[slot].distanceDif = 0.002;
					moGuiMiniPdaSlots.values[slot].clickArea = {};
					moGuiMiniPdaSlots.values[slot].openLastWidth = 0.20;
					moGuiMiniPdaSlots.values[slot].openLastHeight = 0.20;				
					moGuiMiniPdaSlots.values[slot].size = moGuiMiniPdaSlots.sizeDefault;
					moGuiMiniPdaSlots.values[slot].seeInOutFruit = true;
					moGuiMiniPdaSlots.values[slot].seePrice = false;
					moGuiMiniPdaSlots.values[slot].seeSmall = false;
					moGuiMiniPdaSlots.values[slot].hotSpot = false;
					moGuiMiniPdaSlots.values[slot].lengthName = 0;
					moGuiMiniPdaSlots.values[slot].lengthNumber = 0;
					moGuiMiniPdaSlots.values[slot].foundObjects = 0;
					moGuiMiniPdaSlots.values[slot].foundObjectsNamen = "";
					moGuiMiniPdaSlots.values[slot].length = 30;
					local slotAcceptedName = Utils.splitString(" ", moGuiMiniPdaSlots.acceptedName);
					for b=1, moGuiMiniPdaSlots.slotsMax do
						if slotAcceptedName[b] ~= nil and string.len(slotAcceptedName[b]) > 1 then
							if slotName == slotAcceptedName[b] then moGuiMiniPdaSlots.values[slot].length = moGuiMiniPdaSlots.lengthDefault[b];end;
						end;
					end;
					local values = nil;
					--if getXMLInt(moGeneralSettings.xml, groupNameTag.."#switch") then values = getXMLInt(moGeneralSettings.xml, groupNameTag.."#switch");end;	
					--if values ~= nil and values > 0 and string.find(moGuiMiniPdaSlots.acceptedSwitch, slotName.. " ") then moGuiMiniPdaSlots.values[slot].switch = values;end;
					if string.find(moGuiMiniPdaSlots.acceptedSwitch, slotName.. " ") then moGuiMiniPdaSlots.values[slot].switch = 1;end;
					--values = nil;
					if getXMLBool(moGeneralSettings.xml, groupNameTag.."#isOpen") ~= nil then moGuiMiniPdaSlots.values[slot].isOpen = getXMLBool(moGeneralSettings.xml, groupNameTag.."#isOpen");end;
					if getXMLBool(moGeneralSettings.xml, groupNameTag.."#closeOpenHud") ~= nil then moGuiMiniPdaSlots.values[slot].closeOpenHud = getXMLBool(moGeneralSettings.xml, groupNameTag.."#closeOpenHud");end;
					--
					if moGuiMiniPdaSlots.values[slot].closeOpenHud then						
						if getXMLBool(moGeneralSettings.xml, groupNameTag.."#closeAllHud") ~= nil then moGuiMiniPdaSlots.values[slot].closeAllHud = getXMLBool(moGeneralSettings.xml, groupNameTag.."#closeAllHud");end;
						if moGuiMiniPdaSlots.values[slot].isOpen and moGuiMiniPdaSlots.values[slot].closeAllHud then moGuiMiniPdaSlots.values[slot].isOpen = false;moGuiMiniPdaSlots.keySwitchLast = slot;end;					
					end;					
					--
					if getXMLInt(moGeneralSettings.xml, groupNameTag.."#isWarning") then values = getXMLInt(moGeneralSettings.xml, groupNameTag.."#isWarning");end;
					if values ~= nil and values > 0 and string.find(moGuiMiniPdaSlots.acceptedWarning, slotName.. " ") then moGuiMiniPdaSlots.values[slot].isWarning = values;end;
					values = nil;
					if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#openX") then values = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#openX");end;
					if values ~= nil and values < 1.0 and values > 0.0 then	moGuiMiniPdaSlots.values[slot].openX = values;end;
					values = nil;
					if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#openY") then values = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#openY");end;
					if values ~= nil and values < 1.0 and values > 0.0 then moGuiMiniPdaSlots.values[slot].openY = values;end;
					values = nil;
					if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#distanceLine") then values = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#distanceLine");end;
					if values ~= nil and values < 0.013 and values >= 0.003 then moGuiMiniPdaSlots.values[slot].distanceLine = values;end;
					values = nil;
					if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#distanceDif") then values = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#distanceDif");end;
					if values ~= nil and values < 0.013 and values >= 0.001 then moGuiMiniPdaSlots.values[slot].distanceDif = values;end;
					values = nil;
					if getXMLBool(moGeneralSettings.xml, groupNameTag.."#setMouseCursorOn") ~= nil then moGuiMiniPdaSlots.values[slot].setMouseCursorOn = getXMLBool(moGeneralSettings.xml, groupNameTag.."#setMouseCursorOn");end;
					if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeInOutFruit") ~= nil then moGuiMiniPdaSlots.values[slot].seeInOutFruit = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeInOutFruit");end;
					if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seePrice") ~= nil then moGuiMiniPdaSlots.values[slot].seePrice = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seePrice");end;
					if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeSmall") ~= nil then moGuiMiniPdaSlots.values[slot].seeSmall = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeSmall");end;
					if getXMLBool(moGeneralSettings.xml, groupNameTag.."#hotSpot") ~= nil then moGuiMiniPdaSlots.values[slot].hotSpot = getXMLBool(moGeneralSettings.xml, groupNameTag.."#hotSpot");end;
					if getXMLBool(moGeneralSettings.xml, groupNameTag.."#moreInfo") ~= nil then moGuiMiniPdaSlots.values[slot].moreInfo = getXMLBool(moGeneralSettings.xml, groupNameTag.."#moreInfo");end;
					if moGuiMiniPdaSlots.values[slot].moreInfo and not moGuiMiniPdaSlots.values[slot].setMouseCursorOn then moGuiMiniPdaSlots.values[slot].moreInfo = false;end;
					if getXMLBool(moGeneralSettings.xml, groupNameTag.."#permUpdate") ~= nil then moGuiMiniPdaSlots.values[slot].permUpdate = getXMLBool(moGeneralSettings.xml, groupNameTag.."#permUpdate");end;
					if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#size") then values = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#size");end;
					if values ~= nil and values <= moGuiMiniPdaSlots.maxSize and values >= moGuiMiniPdaSlots.minSize then moGuiMiniPdaSlots.values[slot].size = values;end;
					if slotName == "fieldsinfo" then moGuiMiniPdaSlots.fieldsInfo.zoomOutInIcons = moGuiMiniPdaSlots.values[slot].size*100*2;end;
					values = nil;
					if getXMLInt(moGeneralSettings.xml, groupNameTag.."#maxProSwitch") then values = getXMLInt(moGeneralSettings.xml, groupNameTag.."#maxProSwitch");end;
					if values ~= nil and values > 0 then moGuiMiniPdaSlots.values[slot].maxProSwitch = values;end;
					values = nil;
					if getXMLInt(moGeneralSettings.xml, groupNameTag.."#length") then values = getXMLInt(moGeneralSettings.xml, groupNameTag.."#length");end;
					if values ~= nil and values >= moGuiMiniPdaSlots.minLength and values <= moGuiMiniPdaSlots.maxLength then moGuiMiniPdaSlots.values[slot].length = values;end;
					values = nil;
					if moGuiMiniPdaSlots.values[slot].isOpen then moGuiMiniPdaSlots.keySwitchLast = slot;end;
					moGuiExtras:setSlotPositionen(self, slot, false);
				else
					errorSlot = true;
					errorTxt = "(slotName already exists)";
				end;
			else
				errorSlot = true;
				errorTxt = "(slotName not correct)";
			end;
			if errorSlot then
				print("!!!! WARNING !!!! Found corrupt"..  tostring(MultiOverlayV2.metadata.title).. " miniPDA slot=".. a.. " name=".. tostring(slotName).. " ".. tostring(errorTxt));
				print("!!!! Remove slot (manipulate not xml settings) !!!!");				
			end;			
		end;
		if moGuiMiniPdaSlots.values ~= nil and table.getn(moGuiMiniPdaSlots.values) > 0 then 
			moGuiMiniPdaSlots.activeTotal = table.getn(moGuiMiniPdaSlots.values);
			return;
		end;
		moGuiMiniPdaSlots.activeTotal = 0;
		moGuiMiniPdaSlots.isActive = false;				
	end;	
end;

function loadVI(self, xmlNameTag)	
	local groupNameTag = (xmlNameTag.. ".vehicleInspector.values(%d)"):format(0);
	if moGeneralSettings.xml ~= nil and groupNameTag ~= nil then			
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#on") ~= nil then moSetGetGui.pdaVI.on = getXMLBool(moGeneralSettings.xml, groupNameTag.."#on");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#iconDesign") ~= nil then moSetGetGui.pdaVI.iconDesign = getXMLBool(moGeneralSettings.xml, groupNameTag.."#iconDesign");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#speedDisplay") ~= nil then moSetGetGui.pdaVI.speedDisplay = getXMLBool(moGeneralSettings.xml, groupNameTag.."#speedDisplay");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#fieldDisplay") ~= nil then moSetGetGui.pdaVI.fieldDisplay = getXMLBool(moGeneralSettings.xml, groupNameTag.."#fieldDisplay");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#vehicleDisplay") ~= nil then moSetGetGui.pdaVI.vehicleDisplay = getXMLBool(moGeneralSettings.xml, groupNameTag.."#vehicleDisplay");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#backGround") ~= nil then moSetGetGui.pdaVI.backGround = getXMLBool(moGeneralSettings.xml, groupNameTag.."#backGround");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#distanceLine") ~= nil then moSetGetGui.pdaVI.distanceLine = getXMLBool(moGeneralSettings.xml, groupNameTag.."#distanceLine");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#isHiden") ~= nil then moSetGetGui.pdaVI.isHiden = getXMLBool(moGeneralSettings.xml, groupNameTag.."#isHiden");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#cfgHiden") ~= nil then moSetGetGui.pdaVI.cfgHiden = getXMLBool(moGeneralSettings.xml, groupNameTag.."#cfgHiden");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeParked") ~= nil then moSetGetGui.pdaVI.seeParked = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeParked");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeFillLevel") ~= nil then moSetGetGui.pdaVI.seeFillLevel = getXMLBool(moGeneralSettings.xml, groupNameTag.."#seeFillLevel");end;
		if getXMLBool(moGeneralSettings.xml, groupNameTag.."#switchMouseCursorOff") ~= nil then moSetGetGui.pdaVI.switchMouseCursorOff = getXMLBool(moGeneralSettings.xml, groupNameTag.."#switchMouseCursorOff");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#vehicleName") then moSetGetGui.pdaVI.vehicleName = getXMLInt(moGeneralSettings.xml, groupNameTag.."#vehicleName");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#playerName") then moSetGetGui.pdaVI.fullPlayerName = getXMLInt(moGeneralSettings.xml, groupNameTag.."#playerName");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#moreInfo") then moSetGetGui.pdaVI.seeMoreInfo = getXMLInt(moGeneralSettings.xml, groupNameTag.."#moreInfo");end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#hideSwitch") then moSetGetGui.pdaVI.hideSwitch = getXMLInt(moGeneralSettings.xml, groupNameTag.."#hideSwitch");end;		
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#autoPos") then moSetGetGui.pdaVI.autoPos = getXMLInt(moGeneralSettings.xml, groupNameTag.."#autoPos");end;
		if moSetGetGui.pdaVI.autoPos == 1 then moSetGetGui.pdaVI.upDisplay = true;end;
		if getXMLInt(moGeneralSettings.xml, groupNameTag.."#compactDisplay") then moSetGetGui.pdaVI.compactDisplay = getXMLInt(moGeneralSettings.xml, groupNameTag.."#compactDisplay");end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#size") then moSetGetGui.pdaVI.size = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#size");end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#distance") then moSetGetGui.pdaVI.distance = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#distance");end;
		if getXMLFloat(moGeneralSettings.xml, groupNameTag.."#zoomOutIn") then moSetGetGui.pdaVI.zoomOutInVI = getXMLFloat(moGeneralSettings.xml, groupNameTag.."#zoomOutIn");end;
		if moSetGetGui.pdaVI.iconDesign then
			if not moSetGetGui.pdaVI.speedDisplay then moSetGetGui.pdaVI.speedDisplay = true;end;
		end;
	end;
end;


function moSetGetConfigXml:saveConfig(self)
	local file = MultiOverlayV2.settingsDir.. "clientSettings.xml";	
	if moGeneralSettings.saveGameClientSettings then file = MultiOverlayV2.saveGameDir.. "clientSettings.xml";end;
	local Xml = createXMLFile("MultiOverlayV2_XML", file, "clientSettings");
	local xmlNameTag = "clientSettings";
	if Xml ~= nil then		
		--global mod
		local groupNameTag = (xmlNameTag.. ".global.mod(%d)"):format(0);
		setXMLInt(Xml, groupNameTag.. "#updateInterval", MultiOverlayV2.timerUpdate.interval);
		--setXMLBool(Xml, groupNameTag.. "#logSearchMapObjects", moGeneralSettings.logSearchMapObjects);
		setXMLBool(Xml, groupNameTag.. "#artDesign", moGuiMiniPdaSlots.artDesign);		
		if moGuiMiniPdaSlots.artDesign then
			setXMLString(Xml, groupNameTag.. "#artDesignFile", moGuiMiniPdaSlots.artDesignFile);
		end;		
		setXMLBool(Xml, groupNameTag.. "#miniMap", moSetGetGui.miniMap.on);
		setXMLBool(Xml, groupNameTag.. "#helpText", moSetGetGui.helpText);
		setXMLBool(Xml, groupNameTag.. "#wtmHud", moSetGetGui.wtmHud.on);
		setXMLBool(Xml, groupNameTag.. "#vsHud", moSetGetGui.vsHud.on);
		setXMLBool(Xml, groupNameTag.."#closeAllHud", moSetGetGui.closeAllHud);
		setXMLBool(Xml, groupNameTag.. "#adjustZoom", moSetGetGui.adjustZoom);
		setXMLBool(Xml, groupNameTag.. "#screenAspectRatioAuto", moSetGetGui.screenAspectRatioAuto);
		setXMLFloat(Xml, groupNameTag.. "#screenAspectRatio", moSetGetGui.screenAspectRatio);
		setXMLInt(Xml, groupNameTag.. "#multiFarmSilo", moGeneralSettings.multiFarmSilo);					
		setXMLFloat(Xml, groupNameTag.. "#pageCfgPosX", moSetGetGui.posCfgMenue.page[1]);
		setXMLFloat(Xml, groupNameTag.. "#pageCfgPosY", moSetGetGui.posCfgMenue.page[2]);
		setXMLBool(Xml, groupNameTag.. "#trainPrice", moGeneralSettings.isTrainPrice);
		--global mod
		--global miniPda
		groupNameTag = (xmlNameTag.. ".global.miniPda(%d)"):format(0);
		if moGuiMiniPdaSlots.isActive and moGuiMiniPdaSlots.activeTotal == 0 then
			setXMLBool(Xml, groupNameTag.."#isActive", false);
		else
			setXMLBool(Xml, groupNameTag.."#isActive", moGuiMiniPdaSlots.isActive);	
		end;
		setXMLInt(Xml, groupNameTag.. "#activeTotal", moGuiMiniPdaSlots.activeTotal);
		setXMLInt(Xml, groupNameTag.."#warningTakt", moGuiMiniPdaSlots.warningBlinkTime);
		setXMLBool(Xml, groupNameTag.. "#isHiden", moGuiMiniPdaSlots.isHiden);
		setXMLBool(Xml, groupNameTag.."#isKeySwitchActive", moGuiMiniPdaSlots.isKeySwitchActive);		
		setXMLBool(Xml, groupNameTag.. "#combiBgaSilo", moGuiMiniPdaSlots.combiBgaSilo);
		setXMLBool(Xml, groupNameTag.. "#onlyObjectSettings", moGuiMiniPdaSlots.onlyObjectSettings);
		setXMLInt(Xml, groupNameTag.."#alignment", moGuiMiniPdaSlots.alignment);
		setXMLBool(Xml, groupNameTag.. "#isDouble", moGuiMiniPdaSlots.double);
		setXMLBool(Xml, groupNameTag.. "#isTriple", moGuiMiniPdaSlots.triple);		
		setXMLFloat(Xml, groupNameTag.."#zoomOutIn", moGuiMiniPdaSlots.zoomOutIn);
		if moGuiMiniPdaSlots.distanceOut > 0 then 
			setXMLInt(Xml, groupNameTag.."#distanceOut", moGuiMiniPdaSlots.distanceOut);
		else
			if moGuiMiniPdaSlots.distanceIn > 0 then setXMLInt(Xml, groupNameTag.."#distanceIn", moGuiMiniPdaSlots.distanceIn);end;
		end;
		--setXMLFloat(Xml, groupNameTag.."#zoomOutInLevel", moGuiMiniPdaSlots.zoomOutInLevel);
		setXMLFloat(Xml, groupNameTag.."#maxZoom", moGuiMiniPdaSlots.maxZoom);
		setXMLFloat(Xml, groupNameTag.."#minZoom", moGuiMiniPdaSlots.minZoom);
		setXMLFloat(Xml, groupNameTag.."#posX", moGuiMiniPdaSlots.posX);
		setXMLFloat(Xml, groupNameTag.."#posY", moGuiMiniPdaSlots.posY);
		setXMLFloat(Xml, groupNameTag.."#defaultSlotOpenX", moGuiMiniPdaSlots.defaultOpenX);
		setXMLFloat(Xml, groupNameTag.."#defaultSlotOpenY", moGuiMiniPdaSlots.defaultOpenY);
		--global miniPda
		--global vsHud
		groupNameTag = (xmlNameTag.. ".global.vsHud(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#fruitNamesOn", moSetGetGui.vsHud.fruitNamesOn);
		setXMLBool(Xml, groupNameTag.. "#fruitName", moSetGetGui.vsHud.fruitName);
		setXMLBool(Xml, groupNameTag.. "#regName", moSetGetGui.vsHud.descName);
		setXMLFloat(Xml, groupNameTag.. "#fruitNameSize", moSetGetGui.vsHud.fruitNameSize);
		setXMLInt(Xml, groupNameTag.. "#fruitNamePos", moSetGetGui.vsHud.fruitNamePos);
		setXMLBool(Xml, groupNameTag.. "#newFruitHuds", moSetGetGui.vsHud.newFruitHuds);
		setXMLBool(Xml, groupNameTag.. "#fillPriceOn", moSetGetGui.vsHud.fillPriceOn);
		setXMLBool(Xml, groupNameTag.. "#fillPriceIcon", moSetGetGui.vsHud.fillPriceIcon);
		setXMLInt(Xml, groupNameTag.. "#fillPriceStat", moSetGetGui.vsHud.fillPriceStat);
		--global vsHud
		--global wtmHud
		groupNameTag = (xmlNameTag.. ".global.wtmHud(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#newWtmHud", moSetGetGui.wtmHud.mohHud);
		setXMLBool(Xml, groupNameTag.. "#wtmHudRight", moSetGetGui.wtmHud.mohHudRight);
		setXMLFloat(Xml, groupNameTag.. "#size", moSetGetGui.wtmHud.size);
		setXMLFloat(Xml, groupNameTag.. "#zoomOutIn", moSetGetGui.wtmHud.zoomOutIn);
		setXMLInt(Xml, groupNameTag.. "#design", moSetGetGui.wtmHud.design);
		setXMLBool(Xml, groupNameTag.. "#previewWeather", moSetGetGui.wtmHud.previewWeather);
		setXMLBool(Xml, groupNameTag.. "#previewMoneyChangeLast", moSetGetGui.wtmHud.previewMoneyChangeLast);
		setXMLBool(Xml, groupNameTag.. "#lsMoneyChange", moSetGetGui.wtmHud.lsMoneyChange);
		setXMLInt(Xml, groupNameTag.. "#lsMoneyChangeTimer", moSetGetGui.wtmHud.lsMoneyChangeTimer);
		setXMLBool(Xml, groupNameTag.. "#moneyChange", moSetGetGui.wtmHud.moneyChange);
		setXMLBool(Xml, groupNameTag.. "#moneyChangeSound", moSetGetGui.wtmHud.moneyChangeSound);
		setXMLInt(Xml, groupNameTag.. "#moneyChangePos", moSetGetGui.wtmHud.moneyChangePos);
		setXMLBool(Xml, groupNameTag.. "#gameDay", moSetGetGui.wtmHud.gameDay);
		setXMLBool(Xml, groupNameTag.. "#isHiden", moSetGetGui.wtmHud.isHiden);
		setXMLBool(Xml, groupNameTag.. "#realTime", moSetGetGui.wtmHud.realTime);
		setXMLInt(Xml, groupNameTag.. "#realTimeColor", moSetGetGui.wtmHud.realTimeColor);
		setXMLBool(Xml, groupNameTag.. "#seeTemp", moSetGetGui.wtmHud.seeTemp);
		setXMLFloat(Xml, groupNameTag.. "#posX", moSetGetGui.wtmHud.posX);
		setXMLFloat(Xml, groupNameTag.. "#posY", moSetGetGui.wtmHud.posY);
		setXMLBool(Xml, groupNameTag.. "#saveWeather", moSetGetGui.wtmHud.saveWeather);		
		--global wtmHud
		--global fieldsinfo underSettings
		groupNameTag = (xmlNameTag.. ".global.fieldsInfo(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#iconDesign", moGuiMiniPdaSlots.fieldsInfo.iconDesign);
		setXMLInt(Xml, groupNameTag.. "#iconSwitch", moGuiMiniPdaSlots.fieldsInfo.iconSwitch);
		setXMLInt(Xml, groupNameTag.. "#textSwitch", moGuiMiniPdaSlots.fieldsInfo.textSwitch);
		setXMLInt(Xml, groupNameTag.. "#seeFields", moGuiMiniPdaSlots.fieldsInfo.seeFields);
		setXMLBool(Xml, groupNameTag.. "#seeSeeds", moGuiMiniPdaSlots.fieldsInfo.seeSeeds);
		setXMLBool(Xml, groupNameTag.. "#seeHarvest", moGuiMiniPdaSlots.fieldsInfo.seeHarvest);
		setXMLBool(Xml, groupNameTag.. "#seeGrowth", moGuiMiniPdaSlots.fieldsInfo.seeGrowth);
		setXMLBool(Xml, groupNameTag.. "#seeFertilizer", moGuiMiniPdaSlots.fieldsInfo.seeFertilizer);
		setXMLBool(Xml, groupNameTag.. "#seeCut", moGuiMiniPdaSlots.fieldsInfo.seeCut);
		setXMLBool(Xml, groupNameTag.. "#seeRotten", moGuiMiniPdaSlots.fieldsInfo.seeRotten);
		setXMLBool(Xml, groupNameTag.. "#seePlough", moGuiMiniPdaSlots.fieldsInfo.seePlough);
		setXMLBool(Xml, groupNameTag.. "#seeWindrow", moGuiMiniPdaSlots.fieldsInfo.seeWindrow);
		setXMLBool(Xml, groupNameTag.. "#seeBale", moGuiMiniPdaSlots.fieldsInfo.seeBale);
		setXMLBool(Xml, groupNameTag.. "#seeSoil", moGuiMiniPdaSlots.fieldsInfo.seeSoil);
		setXMLBool(Xml, groupNameTag.. "#seeGrass", moGuiMiniPdaSlots.fieldsInfo.seeGrass);
		setXMLBool(Xml, groupNameTag.. "#seeHectar", moGuiMiniPdaSlots.fieldsInfo.seeHectar);
		setXMLBool(Xml, groupNameTag.. "#seeError", moGuiMiniPdaSlots.fieldsInfo.seeError);
		setXMLBool(Xml, groupNameTag.. "#seeFillLevel", moGuiMiniPdaSlots.fieldsInfo.seeFillLevel);
		setXMLBool(Xml, groupNameTag.. "#autoClose", moGuiMiniPdaSlots.fieldsInfo.autoCloseExtraDraw);
		setXMLInt(Xml, groupNameTag.. "#ignoreGrass", moGuiMiniPdaSlots.fieldsInfo.ignoreGrass);
		setXMLInt(Xml, groupNameTag.. "#ignoreMax", moGuiMiniPdaSlots.fieldsInfo.ignoreMax);		
		setXMLInt(Xml, groupNameTag.. "#updateSwitch", moGuiMiniPdaSlots.fieldsInfo.updateSwitch);
		setXMLInt(Xml, groupNameTag.. "#calculation", moGuiMiniPdaSlots.fieldsInfo.calculation);
		setXMLInt(Xml, groupNameTag.. "#extraDrawPos", moGuiMiniPdaSlots.fieldsInfo.extraDrawPos);
		--global fieldsinfo underSettings
		saveWeather(self, Xml, xmlNameTag);
		saveInfo(self, Xml, xmlNameTag);
		savePages(self, Xml, xmlNameTag);
		saveMiniPdaSlots(self, Xml, xmlNameTag);
		saveVI(self, Xml, xmlNameTag);		
		saveXMLFile(Xml);		
	else
		print("!!!! WARNING !!!!".. tostring(MultiOverlayV2.metadata.title).. " save file error "..file);
	end;	
end;

function saveWeather(self, Xml, xmlNameTag)	
	if not MultiOverlayV2.isMp and MultiOverlayV2.event.saveWeather_s and MultiOverlayV2.event.loadWeather_s then
		MultiOverlayV2:saveWeatherServer(self, true)
		--for a=1, 14 do	
		--	local groupNameTag = (xmlNameTag.. ".weather.values(%d)"):format(a-1);
		--	setXMLInt(Xml, groupNameTag.."#day", a);
		--	setXMLInt(Xml, groupNameTag.. "#tempD", moSetGetGui.wtmHud.weatherDays[a].tempDay);
		--	setXMLInt(Xml, groupNameTag.. "#tempN", moSetGetGui.wtmHud.weatherDays[a].tempNight);
		--	setXMLString(Xml, groupNameTag.. "#type", moSetGetGui.wtmHud.weatherDays[a].weatherType);
		--end;
	end;		
end;

function saveInfo(self, Xml, xmlNameTag)	
	if not MultiOverlayV2.isMp then
	end;
end;
	
function savePages(self, Xml, xmlNameTag)
	for a=1, moSetGetGui.maxPage do
		local groupNameTag = (xmlNameTag.. ".pages.values(%d)"):format(a-1);		
		setXMLInt(Xml, groupNameTag.."#page", a);
		setXMLFloat(Xml, groupNameTag.."#size", moSetGetGui.page[a].size);
		setXMLFloat(Xml, groupNameTag.."#maxSize", moSetGetGui.page[a].maxSize);
		setXMLFloat(Xml, groupNameTag.."#minSize", moSetGetGui.page[a].minSize);
		setXMLFloat(Xml, groupNameTag.."#zoomOutInLevel", moSetGetGui.page[a].zoomOutInLevel);
		setXMLInt(Xml, groupNameTag.."#switch", moSetGetGui.page[a].switch);
		setXMLFloat(Xml, groupNameTag.."#posX", moSetGetGui.page[a].posX);
		setXMLFloat(Xml, groupNameTag.."#posY", moSetGetGui.page[a].posY);
		--setXMLBool(Xml, groupNameTag.."#closeAllHud", moSetGetGui.page[a].closeAllHud);
		if a == moSetGetGui.activePage then
			setXMLBool(Xml, groupNameTag.."#isActive", true);
		else
			setXMLBool(Xml, groupNameTag.."#isActive", false);
		end;
		setXMLBool(Xml, groupNameTag.."#isHiden", moSetGetGui.page[a].isHiden);
		if a == 1 then
			setXMLBool(Xml, groupNameTag.."#allPrices", moSetGetGui.page[a].allPrices);
			setXMLBool(Xml, groupNameTag.."#allFruits", moSetGetGui.page[a].allFruits);
			setXMLInt(Xml, groupNameTag.."#maxFruitsProSwitch", moSetGetGui.page[a].maxFruitsProSwitch);
			--setXMLInt(Xml, groupNameTag.."#fruitsSwitch", moSetGetGui.page[a].fruitsSwitch);			
			setXMLInt(Xml, groupNameTag.."#maxStationsProSwitch", moSetGetGui.page[a].maxStationsProSwitch);
		end;
		if a == 2 then
			setXMLBool(Xml, groupNameTag.."#seeGreatDemand", MultiOverlayV2.event.greatDemand_c);
			setXMLBool(Xml, groupNameTag.."#seeDiscount", MultiOverlayV2.event.discount_c);
		end;
	end;
end;

function saveVI(self, Xml, xmlNameTag)			
	local groupNameTag = (xmlNameTag.. ".vehicleInspector.values(%d)"):format(0);
	--setXMLInt(Xml, groupNameTag.."#id", a);
	setXMLBool(Xml, groupNameTag.."#on", moSetGetGui.pdaVI.on);
	setXMLBool(Xml, groupNameTag.."#iconDesign", moSetGetGui.pdaVI.iconDesign);
	setXMLBool(Xml, groupNameTag.."#speedDisplay", moSetGetGui.pdaVI.speedDisplay);
	setXMLBool(Xml, groupNameTag.."#fieldDisplay", moSetGetGui.pdaVI.fieldDisplay);
	setXMLBool(Xml, groupNameTag.."#vehicleDisplay", moSetGetGui.pdaVI.vehicleDisplay);
	setXMLBool(Xml, groupNameTag.."#backGround", moSetGetGui.pdaVI.backGround);
	setXMLBool(Xml, groupNameTag.."#distanceLine", moSetGetGui.pdaVI.distanceLine);	
	setXMLBool(Xml, groupNameTag.."#switchMouseCursorOff", moSetGetGui.pdaVI.switchMouseCursorOff);
	setXMLInt(Xml, groupNameTag.."#vehicleName", moSetGetGui.pdaVI.vehicleName);
	setXMLInt(Xml, groupNameTag.."#playerName", moSetGetGui.pdaVI.fullPlayerName);
	setXMLInt(Xml, groupNameTag.."#moreInfo", moSetGetGui.pdaVI.seeMoreInfo);
	setXMLInt(Xml, groupNameTag.."#hideSwitch", moSetGetGui.pdaVI.hideSwitch);
	setXMLInt(Xml, groupNameTag.."#autoPos", moSetGetGui.pdaVI.autoPos);
	setXMLBool(Xml, groupNameTag.."#isHiden", moSetGetGui.pdaVI.isHiden);
	setXMLBool(Xml, groupNameTag.."#cfgHiden", moSetGetGui.pdaVI.cfgHiden);
	setXMLInt(Xml, groupNameTag.."#compactDisplay", moSetGetGui.pdaVI.compactDisplay);
	setXMLBool(Xml, groupNameTag.."#seeParked", moSetGetGui.pdaVI.seeParked);
	setXMLFloat(Xml, groupNameTag.."#size", moSetGetGui.pdaVI.size);
	setXMLFloat(Xml, groupNameTag.."#distance", moSetGetGui.pdaVI.distance);
	setXMLFloat(Xml, groupNameTag.."#zoomOutIn", moSetGetGui.pdaVI.zoomOutInVI);
	setXMLBool(Xml, groupNameTag.."#seeFillLevel", moSetGetGui.pdaVI.seeFillLevel);
end;

function saveMiniPdaSlots(self, Xml, xmlNameTag)
	if moGuiMiniPdaSlots.values == nil or table.getn(moGuiMiniPdaSlots.values) <= 0 then return;end;	
	for a=1, table.getn(moGuiMiniPdaSlots.values) do				
		local groupNameTag = (xmlNameTag.. ".miniPDA.values(%d)"):format(a-1);
		if moGuiMiniPdaSlots.values[a] ~= nil then
			setXMLInt(Xml, groupNameTag.."#slot", a);
			setXMLString(Xml, groupNameTag.."#name", moGuiMiniPdaSlots.values[a].name);
			--setXMLInt(Xml, groupNameTag.."#switch", moGuiMiniPdaSlots.values[a].switch);
			setXMLBool(Xml, groupNameTag.."#isOpen", moGuiMiniPdaSlots.values[a].isOpen);
			setXMLBool(Xml, groupNameTag.."#closeOpenHud", moGuiMiniPdaSlots.values[a].closeOpenHud);
			setXMLBool(Xml, groupNameTag.."#closeAllHud", moGuiMiniPdaSlots.values[a].closeAllHud);
			setXMLInt(Xml, groupNameTag.."#isWarning", moGuiMiniPdaSlots.values[a].isWarning);
			setXMLFloat(Xml, groupNameTag.."#openX", moGuiMiniPdaSlots.values[a].openX);
			setXMLFloat(Xml, groupNameTag.."#openY", moGuiMiniPdaSlots.values[a].openY);
			setXMLFloat(Xml, groupNameTag.."#size", moGuiMiniPdaSlots.values[a].size);			
			setXMLFloat(Xml, groupNameTag.."#distanceLine", moGuiMiniPdaSlots.values[a].distanceLine);
			setXMLFloat(Xml, groupNameTag.."#distanceDif", moGuiMiniPdaSlots.values[a].distanceDif);
			setXMLBool(Xml, groupNameTag.."#setMouseCursorOn", moGuiMiniPdaSlots.values[a].setMouseCursorOn);
			setXMLBool(Xml, groupNameTag.."#seeInOutFruit", moGuiMiniPdaSlots.values[a].seeInOutFruit);
			setXMLBool(Xml, groupNameTag.."#seePrice", moGuiMiniPdaSlots.values[a].seePrice);
			setXMLBool(Xml, groupNameTag.."#seeSmall", moGuiMiniPdaSlots.values[a].seeSmall);
			setXMLBool(Xml, groupNameTag.."#hotSpot", moGuiMiniPdaSlots.values[a].hotSpot);
			setXMLBool(Xml, groupNameTag.."#moreInfo", moGuiMiniPdaSlots.values[a].moreInfo);
			setXMLBool(Xml, groupNameTag.."#permUpdate", moGuiMiniPdaSlots.values[a].permUpdate);
			setXMLInt(Xml, groupNameTag.."#maxProSwitch", moGuiMiniPdaSlots.values[a].maxProSwitch);
			setXMLInt(Xml, groupNameTag.."#length", moGuiMiniPdaSlots.values[a].length);			
		end;
	end;	
end;