source(MultiOverlayV2.modDir.."scripte/moSetGetInputOutputUpk.lua");
source(MultiOverlayV2.modDir.."scripte/moSetGetInputOutputLs.lua");
source(MultiOverlayV2.modDir.."scripte/moSetGetInputOutputFs.lua");
source(MultiOverlayV2.modDir.."scripte/moSetGetInputOutputSr.lua");
source(MultiOverlayV2.modDir.."scripte/moSetGetInputOutputOther.lua");
moSetGetFillTypes = {};

function moSetGetFillTypes:setFirstFillTypes(self)
	moFillTypes = {};	
	moGeneralSettings.Fillable_NUM_FILLTYPES = Fillable.NUM_FILLTYPES;
	for a=1, Fillable.NUM_FILLTYPES do		
		local desc = Fillable.fillTypeIndexToDesc[a];
		if desc ~= nil then            
			local name = desc.name;
			if g_i18n:hasText(desc.nameI18N) then
                name = g_i18n:getText(desc.nameI18N);
			else
				name = desc.nameI18N
            end				
			if desc.name ~= "choppedStraw" and desc.name ~= "choppedMaize" and desc.name ~= "choppedRape" and desc.name ~= "choppedMaize_haulm" and desc.name ~= "choppedStraw_haulm" and desc.name ~= "choppedRape_haulm" then				
				moFillTypes[desc.index] = {};				
				local checkLeerName = desc.name;
				if string.find(desc.name, " ") then
					checkLeerName = string.gsub(desc.name, " ", "_");
				end;
				local languageFruitName = moLanguageXml:getTxt("fruit_".. string.lower(checkLeerName));
				if languageFruitName ~= "L Error" and languageFruitName ~= "L Missing" then
					desc.nameI18N = languageFruitName;
					name = languageFruitName;
				end;				
				if not string.find(name, "Missing") then					
					--if string.len(name) >= moDefault.lengthFruitName then
					--	moDefault.lengthFruitName = string.len(name);					
					--end;
				else
					if not string.find(desc.name, "Missing") then					
						name = desc.name;						
					else
						local splitMissing = Utils.splitString(" ", desc.name);
						name = "!".. splitMissing[2]
					end;
				end;
				if string.len(name) >= moGeneralSettings.lengthFruitName then
					moGeneralSettings.lengthFruitName = string.len(name);					
				end;
				moFillTypes[desc.index].x = 0;
				moFillTypes[desc.index].z = 0;
				moFillTypes[desc.index].fruitName = name;								
				moFillTypes[desc.index].descName = desc.name;
				moFillTypes[desc.index].bestPrice = 0;
				moFillTypes[desc.index].bestPriceStation = "";
				moFillTypes[desc.index].greatDemandStation = nil;
				moFillTypes[desc.index].greatDemandMultiplier = 1;				
				moFillTypes[desc.index].siloAmountTotalPrice = nil;
				moFillTypes[desc.index].stationPriceMulti = {};
				--moFillTypes[desc.index].stationName = "";		
				moFillTypes[desc.index].pricePerLiter = 0;
				moFillTypes[desc.index].previousHourPrice = 0;				
				moFillTypes[desc.index].stateHourPrice = 0;
				moFillTypes[desc.index].startPricePerLiter = 0;
				moFillTypes[desc.index].moneyTotal = 0;
				moFillTypes[desc.index].partOfEconomy = false;
				moFillTypes[desc.index].siloAmount = {};
				for a=0, 10 do
					moFillTypes[desc.index].siloAmount[a] = {};
					moFillTypes[desc.index].siloAmount[a] = nil;
				end;
				--moFillTypes[desc.index].siloAmount = nil;
				--if desc.name == "manure" or desc.name == "liquidManure" then					
				--	moFillTypes[desc.index].siloAmountCow = nil;
				--	moFillTypes[desc.index].siloAmountPig = nil;
				--	moFillTypes[desc.index].siloAmountBeef = nil;
				--	moFillTypes[desc.index].siloAmountChicken2 = nil;
				--end;
				if Fillable.fillTypeIndexToDesc[desc.index].partOfEconomy ~= nil and Fillable.fillTypeIndexToDesc[desc.index].partOfEconomy or desc.name == "silage" then
					moFillTypes[desc.index].partOfEconomy = true;
				end;
			end;			
		end;
	end;	
	if table.getn(moFillTypes) < 1 then
		MultiOverlayV2.loadError = true;	
	end;
end;

function moSetGetFillTypes:setFirstFruitTypes(self)
	local numFruit = 0;
	moFruitTypes = {};
	for index,fruit in pairs(g_currentMission.fruits) do		
		local fruitDesc = FruitUtil.fruitIndexToDesc[index];		
		if fruitDesc.needsSeeding or fruitDesc.index == FruitUtil.FRUITTYPE_GRASS then
			numFruit = numFruit+1;
			--for index1,fruit1 in pairs(fruitDesc) do
			--	print("index1 und fruit1 ...".. tostring(index1).. "-----".. tostring(fruit1))
			--end;
			moFruitTypes[numFruit] = {};
			moFruitTypes[numFruit].descName = fruitDesc.name;
			moFruitTypes[numFruit].fruitName = fruitDesc.name;			
			local desc = Fillable.fillTypeNameToDesc[fruitDesc.name]
			if desc ~= nil and moFillTypes ~= nil and moFillTypes[desc.index] ~= nil then moFruitTypes[numFruit].fruitName = moFillTypes[desc.index].fruitName;end;			
			moFruitTypes[numFruit].index = FruitUtil.fruitIndexToDesc[index].index;					
			moFruitTypes[numFruit].minPreparingGrowthState = FruitUtil.fruitIndexToDesc[index].minPreparingGrowthState;
			moFruitTypes[numFruit].maxPreparingGrowthState = FruitUtil.fruitIndexToDesc[index].maxPreparingGrowthState;
			moFruitTypes[numFruit].minHarvestingGrowthState = FruitUtil.fruitIndexToDesc[index].minHarvestingGrowthState;
			moFruitTypes[numFruit].maxHarvestingGrowthState = FruitUtil.fruitIndexToDesc[index].maxHarvestingGrowthState;
			moFruitTypes[numFruit].preparedGrowthState = FruitUtil.fruitIndexToDesc[index].preparedGrowthState;
			moFruitTypes[numFruit].preparingOutputName  = FruitUtil.fruitIndexToDesc[index].preparingOutputName;
			moFruitTypes[numFruit].cutState  = FruitUtil.fruitIndexToDesc[index].cutState;
			----
			moFruitTypes[numFruit].fruitMapColor = FruitUtil.fruitIndexToDesc[index].fruitMapColor;
			moFruitTypes[numFruit].literPerSqm = FruitUtil.fruitIndexToDesc[index].literPerSqm;
			moFruitTypes[numFruit].massPerLiter = FruitUtil.fruitIndexToDesc[index].massPerLiter;
			if FruitUtil.fruitIndexToDesc[index].hasWindrow then
				moFruitTypes[numFruit].windrowName = FruitUtil.fruitIndexToDesc[index].windrowName;
				moFruitTypes[numFruit].windrowLiterPerSqm = FruitUtil.fruitIndexToDesc[index].windrowLiterPerSqm;
				if moFruitTypes[numFruit].windrowName ~= nil then
					local desc = Fillable.fillTypeNameToDesc[moFruitTypes[numFruit].windrowName];
					if desc ~= nil and moFillTypes ~= nil and moFillTypes[desc.index] ~= nil then moFruitTypes[numFruit].windrowName = moFillTypes[desc.index].fruitName;end;	
				end;				
			end;
			----
			local ids = g_currentMission.fruits[index];
			if ids ~= nil and ids.id > 0 then
				moFruitTypes[numFruit].id = ids.id;
				moFruitTypes[numFruit].windrowId = ids.windrowId;
				moFruitTypes[numFruit].preparingOutputId = ids.preparingOutputId;				
			end;			
		end;
	end;
end;

function moSetGetFillTypes:setFruitsMaxProSwitch(self)	
	local fruits = moGeneralSettings.Fillable_NUM_FILLTYPES/moSetGetGui.page[1].maxFruitsProSwitch;	
	local maxSwitch = moSetGetGui:round(fruits+0.5);	
	if maxSwitch < 1 then maxSwitch = 1;end;
	moSetGetGui.page[1].maxFruitsSwitch = maxSwitch;
	if moSetGetGui.page[1].fruitsSwitch > maxSwitch then moSetGetGui.page[1].fruitsSwitch = 1;end;
end;

function moSetGetFillTypes:setFruitsFirstEnd(self)	
	if moSetGetGui.page[1].fruitsSwitch == 1 then moSetGetGui.page[1].firstFruit = 1;moSetGetGui.page[1].endFruit = moSetGetGui.page[1].maxFruitsProSwitch;end;
	if moSetGetGui.page[1].fruitsSwitch > 1 then moSetGetGui.page[1].firstFruit = (moSetGetGui.page[1].fruitsSwitch-1)*moSetGetGui.page[1].maxFruitsProSwitch+(1);moSetGetGui.page[1].endFruit = moSetGetGui.page[1].fruitsSwitch*moSetGetGui.page[1].maxFruitsProSwitch;end;
	if moSetGetGui.page[1].endFruit > moGeneralSettings.Fillable_NUM_FILLTYPES then moSetGetGui.page[1].endFruit = moGeneralSettings.Fillable_NUM_FILLTYPES;end;
end;